unit demods;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, XLSExportComp, StdCtrls, ExtCtrls;

type
  TfraDemoDS = class(TFrame)
    mQuery: TMemo;
    XLSExportDataSource1: TXLSExportDataSource;
    Query1: TQuery;
    DataSource2: TDataSource;
    Database2: TDatabase;
    ColorDialog1: TColorDialog;
    XLSExportFile1: TXLSExportFile;
    Panel1: TPanel;
    Label3: TLabel;
    Panel3: TPanel;
    Memo2: TMemo;
    Button2: TButton;
    cb2OpenAfterSave: TCheckBox;
    Panel4: TPanel;
    Label1: TLabel;
    Label6: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    p2Odd: TPanel;
    p2Even: TPanel;
    btn2Even: TButton;
    btn2Odd: TButton;
    cbAlias: TComboBox;
    SaveDialog1: TSaveDialog;
    procedure btn2OddClick(Sender: TObject);
    procedure btn2EvenClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure XLSExportDataSource1SaveField(Field: TField; XLSCell: TCell);
  private
    procedure ConnectBase;
    procedure DisconnectBase;
  public
    { Public declarations }
     constructor Create(AOwner: TComponent); override;
  end;

implementation
{$R *.DFM}

uses XLSFormat, Main;

constructor TfraDemoDS.Create(AOwner: TComponent);
begin
  inherited;
  Session.GetAliasNames(cbAlias.Items);
end;

procedure TfraDemoDS.ConnectBase;
begin
  if Database2.Connected then
    Database2.Connected:= false;
  Database2.Connected:= true;
end;

procedure TfraDemoDS.DisconnectBase;
begin
  Database2.Connected:= false;
end;


procedure TfraDemoDS.btn2OddClick(Sender: TObject);
begin
  ColorDialog1.Color:= p2Odd.Color;
  if ColorDialog1.Execute then
    p2Odd.Color:= ColorDialog1.Color;
end;

procedure TfraDemoDS.btn2EvenClick(Sender: TObject);
begin
  ColorDialog1.Color:= p2Even.Color;
  if ColorDialog1.Execute then
    p2Even.Color:= ColorDialog1.Color;
end;

procedure TfraDemoDS.Button2Click(Sender: TObject);
var
  FileName: String;
begin
  FileName:= GetNextDemoFileName;

  Query1.Close;
  DisconnectBase;

  Database2.AliasName:= cbAlias.Text;
  ConnectBase;

  Query1.SQL.Assign(mQuery.Lines);
  Query1.Open;

  try
    XLSExportFile1.Workbook.Clear;
    XLSExportFile1.Workbook.Sheets.Add('Sheet1');
          
    { Export DataSource data to sheet 0 starting at row 0 column 0.
      All indexes are 0-based }
    XLSExportDataSource1.ExportData(0, 0, 0);
    { Save workbook data to Excel file }
    XLSExportFile1.SaveToFile(FileName);

    if cb2OpenAfterSave.Checked then
      OpenFile(FileName)
    else
      Application.MessageBox(
        PChar('Result saved to ' + FileName), 'File saved', MB_OK)
  finally
    Query1.Close;
    DisconnectBase;
  end;
end;

procedure TfraDemoDS.XLSExportDataSource1SaveField(Field: TField;
  XLSCell: TCell);
begin
  { Cell export event:
    here you can override default exporting options.
    Column is DBGrid column, XLSCell is worksheet cell }

  { Set cell fill pattern and color }
  XLSCell.FillPattern:= xlPatternSolid;
  if (XLSCell.Row mod 2) = 0 then
    XLSCell.FillPatternBGColorIndex:=
      ColorToXLSColorIndex(p2Odd.Color)
  else
    XLSCell.FillPatternBGColorIndex:=
      ColorToXLSColorIndex(p2Even.Color);
end;

end.
