unit democolor;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, 
  StdCtrls, ExtCtrls;

type
  TfraDemoColor = class(TFrame)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Image1: TImage;
    Memo1: TMemo;
    Button3: TButton;
    cbOpenAfterSave: TCheckBox;
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}
uses XLSFile, XLSFormat, Main;

procedure TfraDemoColor.Button3Click(Sender: TObject);
var
  xf: TXLSFile;
  Row, Col: integer;
  FG, BG: TXLColorIndex;
  FileName: String;
begin
  FileName:= GetNextDemoFileName;

  { Create TXLSFile object.
  After creation it contains one sheet }
  xf:= TXLSFile.Create;
  try
    with xf.Workbook.Sheets[0] do
    begin
      for FG:= Low(TXLColorIndex) to High(TXLColorIndex) do
      begin
        Row:= ord(FG) - 1;
        for BG:= Low(TXLColorIndex) to High(TXLColorIndex) do
          begin
            Col:= ord(BG) - 1;
            { Set cell value. Row and column indexes are 0-based }
            Cells[Row, Col].Value:= 'Demo';
            { Set cell fill pattern and color }
            Cells[Row, Col].FillPattern:= xlPatternSolid;
            Cells[Row, Col].FillPatternBGColorIndex:= BG;
            { Set font color }
            Cells[Row, Col].FontColorIndex:= FG;
          end;
      end;
    end;
    { Save workbook data to Excel file }
    xf.SaveAs(FileName);
  finally
    xf.Destroy;
  end;

  if cbOpenAfterSave.Checked then
    OpenFile(FileName)
  else
    Application.MessageBox(
      PChar('Result saved to ' + FileName), 'File saved', MB_OK);
end;

end.
