unit demoformula;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TfraDemoFormulas = class(TFrame)
    Panel1: TPanel;
    Label1: TLabel;
    Panel2: TPanel;
    Memo1: TMemo;
    Button3: TButton;
    cbOpenAfterSave: TCheckBox;
    Panel3: TPanel;
    Label2: TLabel;
    Memo2: TMemo;
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation
{$R *.DFM}

uses XLSFile, Main;

procedure TfraDemoFormulas.Button3Click(Sender: TObject);
var
  xf: TXLSFile;
  FileName: String;
begin
  FileName:= GetNextDemoFileName;

  { Create TXLSFile object.
    After creation it contains one sheet }
  xf:= TXLSFile.Create;
  try
    with xf.Workbook.Sheets[0] do
    begin
      { Set cell value }
      Cells[0, 0].Value:= 1;
      { Set cell formula }
      Cells[0, 1].Formula:= '100+A1';
      Cells[1, 1].Formula:= 'SUM(A1:A100)';
      Cells[2, 1].Formula:= 'A1+B1';
      Cells[3, 1].Formula:= 'ROW()';
      Cells[4, 1].Formula:= 'SIN(1+COS(2))';
      Cells[5, 1].Formula:= 'MAX(A1;A2;A3)';
      Cells[6, 1].Formula:= 'MAX(A1:A3)';
      Cells[7, 1].Formula:= 'LEN("text constant")';
    end;
    { Save workbook data to Excel file }
    xf.SaveAs(FileName);
  finally
    xf.Destroy;
  end;

  if cbOpenAfterSave.Checked then
    OpenFile(FileName)
  else
    Application.MessageBox(
      PChar('Result saved to ' + FileName), 'File saved', MB_OK);
end;

end.
