unit demorange;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TfraDemoRanges = class(TFrame)
    Panel1: TPanel;
    Label1: TLabel;
    Panel2: TPanel;
    Memo1: TMemo;
    Button3: TButton;
    cbOpenAfterSave: TCheckBox;
    Panel3: TPanel;
    Label2: TLabel;
    Image1: TImage;
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation
{$R *.DFM}

uses XLSFile, XLSFormat, XLSWorkbook, Main;

procedure TfraDemoRanges.Button3Click(Sender: TObject);
var
  xf: TXLSFile;
  R: TRange;
  FileName: String;
begin
  FileName:= GetNextDemoFileName;

  { Create TXLSFile object.
    After creation it contains one sheet }
  xf:= TXLSFile.Create;
  try
    with xf.Workbook.Sheets[0] do
    begin
      { Create new range in sheet }
      R:= Ranges.Add;
      { Range can create many rectangle areas }
      R.AddRect(0,2,0,2);
      R.AddRect(3,5,3,5);
      { Create border for range }
      R.BordersOutline(xlColorBlue, bsThick);
      { Set value for all range cells }
      R.Value:= 10;

      { Create new range in sheet }
      R:= Ranges.Add;
      R.AddRect(6,9,1,5);
      R.MergeCells;
      R.Value:= 'Merged cells';
      R.HAlign:= xlHAlignCenter;
      R.Valign:= xlVAlignCenter;
      R.FontHeight:= 20;
      R.FontColorIndex:= xlColorWhite;
      R.FillPatternBGColorIndex:= xlColorDarkBlue;
      R.FillPattern:= xlPatternSolid;
      R.BordersOutline(xlColorRed, bsDouble);
    end;

    { Save workbook data to Excel file }
    xf.SaveAs(FileName);
  finally
    xf.Destroy;
  end;

  if cbOpenAfterSave.Checked then
    OpenFile(FileName)
  else
    Application.MessageBox(
      PChar('Result saved to ' + FileName), 'File saved', MB_OK);
end;

end.
