unit demorotation;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, 
  ExtCtrls, StdCtrls;

type
  TfraDemoRotation = class(TFrame)
    Panel1: TPanel;
    Label1: TLabel;
    Panel2: TPanel;
    Memo1: TMemo;
    Button3: TButton;
    cbOpenAfterSave: TCheckBox;
    Panel3: TPanel;
    Label2: TLabel;
    Image1: TImage;
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation
{$R *.DFM}

uses XLSFile, XLSFormat, Main;

procedure TfraDemoRotation.Button3Click(Sender: TObject);
var
  xf: TXLSFile;
  FileName: String;
begin
  FileName:= GetNextDemoFileName;

  { Create TXLSFile object.
    After creation it contains one sheet }
  xf:= TXLSFile.Create;
  try
    with xf.Workbook.Sheets[0] do
    begin
      { Set cell rotation style }
      Cells[1, 1].Rotation:= xlRotationNone;
      { Set cell value}
      Cells[1, 1].Value:= 'Demo';
    
      Cells[2, 1].Rotation:= xlRotationTextVerticalCharHorizontal;
      Cells[2, 1].Value:= 'Demo';
      Cells[3, 1].Rotation:= xlRotation45Up;
      Cells[3, 1].Value:= 'Demo';
      Cells[4, 1].Rotation:= xlRotation45Down;
      Cells[4, 1].Value:= 'Demo';
      Cells[5, 1].Rotation:= xlRotationVerticalUp;
      Cells[5, 1].Value:= 'Demo';
      Cells[6, 1].Rotation:= xlRotationVerticalDown;
      Cells[6, 1].Value:= 'Demo';
    end;

    { Save workbook data to Excel file }
    xf.SaveAs(FileName);
  finally
    xf.Destroy;
  end;

  if cbOpenAfterSave.Checked then
    OpenFile(FileName)
  else
    Application.MessageBox(
      PChar('Result saved to ' + FileName), 'File saved', MB_OK);
end;

end.
