unit demosgrid;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, ExtCtrls, XLSExportComp;

type
  TfraDemoSGrid = class(TFrame)
    StringGrid1: TStringGrid;
    ColorDialog1: TColorDialog;
    XLSExportFile1: TXLSExportFile;
    XLSExportStringGrid1: TXLSExportStringGrid;
    Panel1: TPanel;
    Label4: TLabel;
    Panel2: TPanel;
    Memo4: TMemo;
    Button3: TButton;
    cb3OpenAfterSave: TCheckBox;
    Panel3: TPanel;
    Label5: TLabel;
    Label9: TLabel;
    ed3Substr: TEdit;
    cb3Font: TCheckBox;
    p3Color: TPanel;
    Button4: TButton;
    ed3Replace: TEdit;
    cb3Replace: TCheckBox;
    cb3Bold: TCheckBox;
    cb3Italic: TCheckBox;
    cb3Underline: TCheckBox;
    Label2: TLabel;
    SaveDialog1: TSaveDialog;
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure XLSExportStringGrid1SaveCell(Row, Col: Integer;
      XLSCell: TCell);
  private
    { Private declarations }
  public
    { Public declarations }
     constructor Create(AOwner: TComponent); override;
  end;

implementation

{$R *.DFM}
uses XLSFormat, Main;

constructor TfraDemoSGrid.Create(AOwner: TComponent);
var
  R, C: Integer;
begin
  inherited;
  { fill a string grid with some test data }
  StringGrid1.ColCount:= 10;
  StringGrid1.RowCount:= 100;
  for R:= 0 to StringGrid1.RowCount-1 do
    StringGrid1.RowHeights[R]:= StringGrid1.DefaultRowHeight * ((R mod 2) + 1);

  for C:= 0 to StringGrid1.ColCount-1 do
    StringGrid1.ColWidths[C]:= StringGrid1.DefaultColWidth * ((C mod 2) + 1);

  for R:= 0 to StringGrid1.RowCount-1 do
    for C:= 0 to StringGrid1.ColCount-1 do
      if ((R + C) mod 4 = 0) then
        StringGrid1.Cells[R, C]:= 'test';
end;

procedure TfraDemoSGrid.Button4Click(Sender: TObject);
begin
  ColorDialog1.Color:= p3Color.Color;
  if ColorDialog1.Execute then
    p3Color.Color:= ColorDialog1.Color;
end;

procedure TfraDemoSGrid.Button3Click(Sender: TObject);
var
  FileName: String;
begin
  FileName:= GetNextDemoFileName;

  XLSExportFile1.Workbook.Clear;
  XLSExportFile1.Workbook.Sheets.Add('Sheet1');

  XLSExportStringGrid1.ExportData(0, 0, 0);
  XLSExportFile1.SaveToFile(FileName);
  if cb3OpenAfterSave.Checked then
    OpenFile(FileName)
  else
    Application.MessageBox(
      PChar('Result saved to ' + FileName), 'File saved', MB_OK);
end;

procedure TfraDemoSGrid.XLSExportStringGrid1SaveCell(Row, Col: Integer;
  XLSCell: TCell);
var
  S: string;
begin
  { Cell export event:
    here you can override default exporting options.
    Row is StringGrid row, Col is StringGrid column,
    XLSCell is worksheet cell}

  S:= XLSCell.Value;
  if Pos(ed3Substr.Text, S)> 0 then
  begin
    { set cell value }
    if cb3Replace.Checked then
      XLSCell.Value:= ed3Replace.Text;
    { set cell font color }
    if cb3Font.Checked then
      XLSCell.FontColorIndex:= ColorToXLSColorIndex(p3Color.Color);
    { set cell font style }
    if cb3Bold.Checked then
      XLSCell.FontBold:= True;
    if cb3Italic.Checked then
      XLSCell.FontItalic:= True;
    if cb3Underline.Checked then
      XLSCell.FontUnderline:= True;
  end;
end;

end.
